; ------------------------------------------------------------
; Merge List Sort DEMO - by horst.schaeffer@gmx.net 08 Sep 2011
; ------------------------------------------------------------
#totalElements = 100000  

Structure foo   ; element structure of our demo list
 name.s         ; will hold a random number string 
 other.i        ; not used in this demo 
EndStructure 

Global NewList DemoList.foo()   ; User's list defined before IncludeFile

; -------------------------------------------------------------------
; UserList() is dummy name in MLsort.pbi
Macro UserList() : DemoList() : EndMacro   ; this "renames" UserList() to DemoList()
IncludeFile "MLsort.pbi" 
; --------------------------------------------------------------------

; These are two simple comparisons: 

Procedure ByNameAscending(*first.foo,*second.foo) 
  If *first\name <= *second\name : rightOrder = #True : EndIf  
ProcedureReturn rightOrder  
EndProcedure 

Procedure ByNameDescending(*first.foo,*second.foo) 
  If *first\name >= *second\name : rightOrder = #True : EndIf 
ProcedureReturn rightOrder   
EndProcedure 

; ------------------------------------------------------------
;- Test Section 
; ------------------------------------------------------------

; ------------------ verify correct order, error msg
Macro verify(gt_lt) ; > for ascending, < for descending
  *el2.foo = FirstElement(DemoList())
  errors = 0
  Repeat 
    *el1.foo = *el2
    *el2.foo = NextElement(DemoList())
    If *el2 And *el1\name gt_lt *el2\name
      errors +1
    EndIf
  Until *el2 = 0
  emsg$ = ""
  If errors : emsg$ = #CR$ + Str(errors)+" errors" : EndIf 
EndMacro  
; ------------------

title.s = "MLsort (string) "
elements.s = Str(#totalElements)+ " elements" + #CRLF$

For i = 1 To #totalElements         ; make demo list with random strings
  AddElement(DemoList())
  DemoList()\name = RSet(Str(Random(#totalElements)),6,"0")  
Next
MessageRequester(title,"Start test")

t = ElapsedMilliseconds()
LLmergeSort(@ByNameAscending())  
t = ElapsedMilliseconds() -t
verify(>)
MessageRequester(title,elements + "random -> ascending: " +Str(t)+ " ms" + emsg$)

t = ElapsedMilliseconds()
LLmergeSort(@ByNameDescending())  
t = ElapsedMilliseconds() -t
verify(<)
MessageRequester(title,elements + "ascending -> descending: " +Str(t)+ " ms" + emsg$)

End 


; IDE Options = PureBasic 4.60 Beta 4 (Windows - x86)
; CursorPosition = 1
; FirstLine = 33
; Folding = -
; EnableXP
; Executable = MLtest.exe
; DisableDebugger
; CompileSourceDirectory